//*****************************************************************
// File:   PuntoAlquiler.hpp
// Author: PSCD-Unizar
// Date:   noviembre 2019
// Coms:
//*****************************************************************

#ifndef PUNTO_ALQUILER
#define PUNTO_ALQUILER

#include <iostream>
#include <string>
#include <mutex>
#include <condition_variable>

using namespace std;

//-----------------------------------------------------
//  Compilación condicional: ¿quiero hacer "logging"? Modo no-main: var "logger" se declarará en el "main"
#ifdef LOGGING_MODE
    #include <Logger.hpp>
    extern Logger logger;
#else
    #ifndef ADD_EVENT //para evitar redefiniciones
        #define ADD_EVENT(e)  // nada
    #endif
#endif



class PuntoAlquiler {
public:
    //----------------- Constructor
    // Punto de alquiler con <nTandems> tándems y <nBicis> bicicletas individuales
    PuntoAlquiler(const int nTandems, const int nBicis);

    //----------------- Destructor
    ~PuntoAlquiler();

    // Se bloquea hasta que al cliente <id> es le puede conceder una bicicleta individual (en cuyo caso <idPareja>=0)
    // o se le puede conceder un tandem con un compañero, en cuyo caso <idPareja> tendrá su identificador
    void solicitarBicicleta(const int id, int& idPareja);

    // Devuelve la bicicleta o el tándem, de acuerdo con el enunciado
    void devolverBicicleta(const int id, const int idPareja);

private:
    int bicisDisp, tandemsDisp;
    // ...
};
#endif
